#define DEF_INT_PROTO_FUNCTION0(obj,fname)				\
int C_Py##obj##_##fname(PyObject *self) {				\
	Py##obj *pm = (Py##obj *)self;					\
									\
	PyObject *r = PyObject_CallFunction(pm->fname, "");		\
	int rr;								\
	if (r == NULL) {						\
		PyErr_Print();						\
		return -1;						\
	}								\
	rr = PyInt_AsLong(r);						\
	Py_DECREF(r);							\
	return rr;							\
}

#define DEF_PROTO_FUNCTION1(obj,fname,at1,an1,f)			\
void C_Py##obj##_##fname(PyObject *self,at1 an1) {			\
	Py##obj *pm = (Py##obj *)self;					\
	PyObject *rval;							\
	rval = PyObject_CallFunction(pm->fname, f, an1);		\
	if (rval == NULL)						\
		PyErr_Print();						\
	else								\
		Py_DECREF(rval);					\
}

#define DEF_PROTO_FUNCTION2(obj,fname,at1,an1,at2,an2,f)		\
void C_Py##obj##_##fname(PyObject *self,at1 an1, at2 an2) {		\
	Py##obj *pm = (Py##obj *)self;					\
	PyObject *rval;							\
	rval = PyObject_CallFunction(pm->fname, f, an1, an2);		\
	if (rval == NULL)						\
		PyErr_Print();						\
	else								\
		Py_DECREF(rval);					\
}

#define DEF_PROTO_FUNCTION3(obj,fname,at1,an1,at2,an2,at3,an3,f)	\
void C_Py##obj##_##fname(PyObject *self,at1 an1, at2 an2, at3 an3) {	\
	Py##obj *pm = (Py##obj *)self;					\
	PyObject *rval;							\
	rval = PyObject_CallFunction(pm->fname, f, an1, an2, an3);	\
	if (rval == NULL)						\
		PyErr_Print();						\
	else								\
		Py_DECREF(rval);					\
}

#define SET_PROTO_FUNCTION(obj,fname)					\
static PyObject *Py##obj##_Set##fname(PyObject *self, PyObject *args)	\
{									\
	PyObject *f;							\
	Py##obj *pm = (Py##obj *)self;					\
	if (!PyArg_ParseTuple(args, "O", &f)) {				\
		return NULL;						\
	}								\
	Py_DECREF(pm->fname);						\
	Py_INCREF(f);							\
	pm->fname = f;							\
	Py_INCREF(Py_None);						\
	return Py_None;							\
}


