from xml.parsers.expat import ParserCreate

class TipException:
	pass

class UnrecognisedStartTagException(TipException): 
	def __init__(this, name):
		this.string = name + ": unrecognised start tag"

class BadEndTagException(TipException):
	def __init__(this, name):
		this.string = name + " does not match start tag"

class DictEntry:
	def __init__(this, start_callback, data_callback, end_callback):
		this.start_callback = start_callback
		this.end_callback = end_callback
		this.data_callback = data_callback
		this.subdict = {}
	def __str__(this):
		return str(this.start_callback) + " | " + \
			str(this.data_callback) + " | " + \
			str(this.end_callback) + " | " + str(this.subdict)

class DictParser:
	def __init__(this, file):
		this.parser = ParserCreate()
		this.parser.EndElementHandler = this._end
		this.parser.StartElementHandler = this._start
		this.parser.CharacterDataHandler = this._data
		this.base_de = DictEntry(None, None, None)
		this.de_stack = [this.base_de]
		this.name_stack = [""]
		this.file = file
	def go(this):
		this.parser.ParseFile(this.file)
		
	def _start(this, name, args):
		try:
			de = this.de_stack[-1].subdict[name]
		except:
			raise UnrecognisedStartTagException(name)
		this.de_stack.append(de)
		this.name_stack.append(name)
		if de.start_callback is not None:
			de.start_callback(name, args)
	
	def _end(this, name):
		if not name == this.name_stack[-1]:
			raise BadEndTagException(name)
		del this.name_stack[-1]
		if this.de_stack[-1].end_callback is not None:
			this.de_stack[-1].end_callback(name)
		del this.de_stack[-1]
		
	def _data(this, data):
		if this.de_stack[-1].data_callback is not None:
			this.de_stack[-1].data_callback(data)
		
	def add_tag(this, name, de, tree = []):
		pde = this.base_de
		for tname in tree:
			pde = pde.subdict[tname]
		pde.subdict[name] = de
