#include "TograIncludes.h"
#include <stdlib.h>

MsgQueue *NewQueue (void);

MsgQueue *NewQueue() {
	MsgQueue *queue = malloc(sizeof(MsgQueue));
	queue->msgs = malloc(QUEUE_DEFAULT_LENGTH * sizeof(Msg));

	queue->queue_length = 0;
	queue->queue_alloced = QUEUE_DEFAULT_LENGTH;

	return queue;

}

void DelQueue(MsgQueue *queue) {

	assert(queue->queue_length == 0);
	
	if (queue->queue_alloced > 0)
	{
		free(queue->msgs);
	}
		
	free(queue);
}

void AppendMessage(MsgQueue *queue, int msg_type, PyObject *msg_src,
		PyObject *msg_info) {

	if (queue->queue_length == queue->queue_alloced)
	{
		queue->queue_alloced *= 2;
		queue->msgs = realloc(queue->msgs, 
				queue->queue_alloced * sizeof(Msg));
	}

	queue->msgs[queue->queue_length].msg_type = msg_type;
	queue->msgs[queue->queue_length].msg_src = msg_src;
	queue->msgs[queue->queue_length++].msg_info = msg_info;

}

void SendMessages(MsgQueue *queue, PyObject *function) {

	PyObject *list;
	PyObject *tuple;
	PyObject *rargs;
	int i;
	Msg *msg;

	if (queue->queue_length == 0)
		return;

	if (function == NULL)
	{
		queue->queue_length = 0;
		return;
	}
	
	list = PyList_New(queue->queue_length);
	msg = queue->msgs;

		
	
	for (i = 0; i < queue->queue_length; i++)
	{
		if (msg->msg_info != NULL) {
			int len;
			int j;
			
			if ((PyTuple_Check(msg->msg_info)) == 0) {
				tuple = PyTuple_New(3);
				PyTuple_SetItem(tuple, 0, 
					PyInt_FromLong(msg->msg_type));
				PyTuple_SetItem(tuple, 1, msg->msg_src);
				PyTuple_SetItem(tuple, 2, msg->msg_info);
			} else {
			
			
				len = PySequence_Size(msg->msg_info);
			
				tuple = PyTuple_New(len + 2);
				PyTuple_SetItem(tuple, 0, 
					PyInt_FromLong(msg->msg_type));
				PyTuple_SetItem(tuple, 1, msg->msg_src);
				for (j = 0; j < len; j++)
				{
					PyTuple_SetItem(tuple, j + 2,
						PySequence_GetItem(
							msg->msg_info, j));
				}
			}
		} else {
			tuple = PyTuple_New(2);
			PyTuple_SetItem(tuple, 0, 
					PyInt_FromLong(msg->msg_type));
			PyTuple_SetItem(tuple, 1, msg->msg_src);
		}
		
		PyList_SetItem(list, i, tuple);
		msg++;
	}

	rargs = PyTuple_New(1);
	PyTuple_SetItem(rargs, 0, list);
	
	queue->queue_length = 0;

	if (PyObject_CallObject(function, rargs) == NULL)
	{
		printf("Exception during deferred callbacks:\n");
		PyErr_Print();
	}
}
