/*
 * Copyright 2003, Shane Stephens.
 *
 * This work is protected by the BSD license.  Please see license.txt in the
 * root directory for more information.
 */

#include "TograIncludes.h"

TOGRA_DEFINE_RENDER(ProtoRender)

void *C_PyProtoRender_New(void) {

	PyProtoRender *om = PyObject_New(PyProtoRender, &PyProtoRenderType);
	D_ALLOC(om, "ProtoRender");

	om->interfaces = &PyProtoRender_Interfaces;
	om->Render = Py_None;
	om->Compile = Py_None;

	Py_INCREF(Py_None);
	Py_INCREF(Py_None);

	return (void *)om;

}

PyObject *PyProtoRender_New(PyObject *self, PyObject *args) {

	return C_PyProtoRender_New();

}

DEF_PROTO_FUNCTION2(ProtoRender, Render, int, time, int, picking, "i")
DEF_INT_PROTO_FUNCTION0(ProtoRender, Compile)

void PyProtoRender_Free(PyObject *self) {

	D_FREE(self, "ProtoRender");

}

SET_PROTO_FUNCTION(ProtoRender, Render)
SET_PROTO_FUNCTION(ProtoRender, Compile)

static PyMethodDef PyProtoRender_methods[] = {
	{"setRender", (PyCFunction)PyProtoRender_SetRender, METH_VARARGS,
		"set the init function of this mixin object"},
	{"setCompile", (PyCFunction)PyProtoRender_SetCompile, METH_VARARGS,
		"set the renderStep function of this mixin object"},
	{NULL, NULL, 0, NULL}
};

static PyObject *PyProtoRender_GetAttr(PyObject *self, char *name) {
	return Py_FindMethod(PyProtoRender_methods, self, name);
}

TOGRA_DEFINE_GETATTR_OBJECT(ProtoRender)
