/*
 * Copyright 2003, Shane Stephens.  
 *
 * This work is protected by the BSD license.  Please see license.txt in the
 * root directory for more information.
 */

#include <sys/time.h>
#if USE_GLUT
#include <time.h>
#else
#include <glib.h>
#endif

static struct timeval offset;

void InitTime(void)
{
	
	gettimeofday(&offset, NULL);
	
}

unsigned long GetTime(void)
{
	unsigned long val;
#if USE_GLUT
	struct timeval time;
		
	gettimeofday(&time, NULL);
	
	time.tv_sec -= offset.tv_sec;
	time.tv_usec -= offset.tv_usec;
	
	val = time.tv_sec * 1000 + (time.tv_usec / 1000);
	
#else
	GTimeVal time;

	g_get_current_time (&time);

	val = time.tv_sec * 1000 + (time.tv_usec / 1000);
#endif
	return val;
}
