#include "TograIncludes.h"
#include "PyBezierInterpolation_common.h"

int C_PyBezierInterpolation_TransformByMe(PyObject *this, PyObject *a, 
		PyObject *b, double fraction) {

	PyObject *accum;
	PyObject *accum2;
	double i1, i2, i3, i4;
	PyObject *vec1, *vec2, *vec3, *vec4;

	/*
	 * Bezier constants
	 */
	i1 = (1 - fraction) * (1 - fraction) * (1 - fraction);
	i2 = 3 * fraction * (1 - fraction) * (1 - fraction);
	i3 = 3 * fraction * fraction * (1 - fraction);
	i4 = fraction * fraction * fraction;

	vec1 = PyTuple_GetItem(a, 0);
	IVECTOR_ADD(vec1, PyTuple_GetItem(a, 2), &vec2);
	vec4 = PyTuple_GetItem(b, 0);
	IVECTOR_ADD(vec4, PyTuple_GetItem(b, 1), &vec3);

	IVECTOR_MULTIPLYSCALAR(vec1, i1, &accum);
	IVECTOR_MULTIPLYSCALAR(vec2, i2, &accum2);
	IVECTOR_ADD(accum, accum2, &accum);
	IVECTOR_MULTIPLYSCALAR(vec3, i3, &accum2);
	IVECTOR_ADD(accum, accum2, &accum);
	IVECTOR_MULTIPLYSCALAR(vec4, i4, &accum2);
	IVECTOR_ADD(accum, accum2, &accum);
	
	IVECTOR_TRANSLATEBYME(accum);

	return 1;
}


int C_PyBezierInterpolation_InvertByMe(PyObject *this, PyObject *a, 
		PyObject *b, double fraction) {

	PyObject *accum;
	PyObject *accum2;
	double i1, i2, i3, i4;
	PyObject *vec1, *vec2, *vec3, *vec4;

	/*
	 * Bezier constants
	 */
	i1 = -(1 - fraction) * (1 - fraction) * (1 - fraction);
	i2 = -3 * fraction * (1 - fraction) * (1 - fraction);
	i3 = -3 * fraction * fraction * (1 - fraction);
	i4 = -fraction * fraction * fraction;

	vec1 = PyTuple_GetItem(a, 0);
	IVECTOR_ADD(vec1, PyTuple_GetItem(a, 2), &vec2);
	vec4 = PyTuple_GetItem(b, 0);
	IVECTOR_ADD(vec4, PyTuple_GetItem(b, 1), &vec3);

	IVECTOR_MULTIPLYSCALAR(vec1, i1, &accum);
	IVECTOR_MULTIPLYSCALAR(vec2, i2, &accum2);
	IVECTOR_ADD(accum, accum2, &accum);
	IVECTOR_MULTIPLYSCALAR(vec3, i3, &accum2);
	IVECTOR_ADD(accum, accum2, &accum);
	IVECTOR_MULTIPLYSCALAR(vec4, i4, &accum2);
	IVECTOR_ADD(accum, accum2, &accum);

	IVECTOR_TRANSLATEBYME(accum);

	return 1;
}
