#include "TograIncludes.h"
#include "PyContainer_common.h"

int C_PyContainer_Compile(PyObject *self, int *result) {

        PyContainer *c = (PyContainer *)self;
        int i;
	int r;
        
	for (i = 0; i < c->childrenSize; i++) {
                if (!IRENDER_COMPILE(c->children[i], &(r)))
			return 0;
		if (r == 0)
			c->is_static = 0;
        }
        
        *result = c->is_static;
	return 1;
        
}

int C_PyContainer_Render(PyObject *self, int time, int picking) {
	
        PyContainer *c = (PyContainer *)self;
	int i;

	glLoadName((int)self);
	
	glPushMatrix();

        if (c->transformContainer != NULL) {
		ITRANSFORM_GENERATETRANSFORM(c->transformContainer, 
				c->status, time, 1, 0, 1);
	}

        if ((c->material != NULL) && (!picking))
        {
                IMATERIAL_SETMATERIAL(c->material, time);
        }
      
	for (i = 0; i < c->childrenSize; i++) {
		IRENDER_RENDER(c->children[i], time, picking);
	}
        
        if ((c->material != NULL) && (!picking))
        {
                IMATERIAL_UNSETMATERIAL(c->material, time);
        } 
        
	glPopMatrix();

	glLoadName(0);

	return 1;
}
