#include "TograIncludes.h"
#include "PyMaterial_common.h"

inline void _C_PyMaterial_SetMaterial(PyMaterial *m, int time)
{
	float *values;
	ICOLOUR_VALUES(m->ambient, &values);
        glMaterialfv(GL_FRONT, GL_AMBIENT_AND_DIFFUSE, values);
	ICOLOUR_VALUES(m->specular, &values);
        glMaterialfv(GL_FRONT, GL_SPECULAR, values);
        glMaterialf(GL_FRONT, GL_SHININESS, m->shininess);
	ICOLOUR_VALUES(m->emissive, &values);
        glMaterialfv(GL_FRONT, GL_EMISSION, values);	

        if (m->texture != NULL) {
                glTexEnvi(GL_TEXTURE_ENV, GL_TEXTURE_ENV_MODE, GL_BLEND);
		ITEXTURE_SETTEXTURE(m->texture, time);
        } else {
                glDisable(GL_TEXTURE_2D);
        }

}

extern PyMaterial *current_colour;

int C_PyMaterial_SetMaterial(PyObject *self, int time)
{
        PyMaterial *m = (PyMaterial *)self;

        m->old_colour = (PyObject *)current_colour;
        current_colour = m;

        _C_PyMaterial_SetMaterial(current_colour, time);

	return 1;
}

int C_PyMaterial_UnsetMaterial(PyObject *self, int time)
{
        PyMaterial *m = (PyMaterial *)self;
        current_colour = (PyMaterial *)m->old_colour;

        _C_PyMaterial_SetMaterial(current_colour, time);

	return 1;
}
