#include "TograIncludes.h"
#include "PyRotationInterpolation_common.h"

int C_PyRotationInterpolation_TransformByMe(PyObject *this, PyObject *a, 
		PyObject *b, double fraction) {

	PyObject *accum;

	PyObject *axis1, *axis2;
	double rot1, rot2, outrot;

	axis1 = PyTuple_GetItem(a, 0);
	rot1 = PyFloat_AsDouble(PyTuple_GetItem(a, 1));
	axis2 = PyTuple_GetItem(b, 0);
	rot2 = PyFloat_AsDouble(PyTuple_GetItem(b, 1));

	IVECTOR_MULTIPLYSCALAR(axis1, 1.0 - fraction, &axis1);
	IVECTOR_MULTIPLYSCALAR(axis2, fraction, &axis2);
	IVECTOR_ADD(axis1, axis2, &accum);

	outrot = (1.0 - fraction) * rot1 + fraction * rot2;
	
	IVECTOR_ROTATEBYME(accum, outrot);

	return 1;
}


int C_PyRotationInterpolation_InvertByMe(PyObject *this, PyObject *a, 
		PyObject *b, double fraction) {

	PyObject *accum;

	PyObject *axis1, *axis2;
	double rot1, rot2, outrot;

	axis1 = PyTuple_GetItem(a, 0);
	rot1 = PyFloat_AsDouble(PyTuple_GetItem(a, 1));
	axis2 = PyTuple_GetItem(b, 0);
	rot2 = PyFloat_AsDouble(PyTuple_GetItem(b, 1));

	IVECTOR_MULTIPLYSCALAR(axis1, 1.0 - fraction, &axis1);
	IVECTOR_MULTIPLYSCALAR(axis2, fraction, &axis2);
	IVECTOR_ADD(axis1, axis2, &accum);

	outrot = (1.0 - fraction) * rot1 + fraction * rot2;
	
	IVECTOR_ROTATEBYME(accum, -outrot);

	return 1;
}
