/*
 * Copyright 2003, Shane Stephens.  
 *
 * This work is protected by the BSD license.  Please see license.txt in the
 * root directory for more information.
 */
#include "TograIncludes.h"
#include "PyTransform_common.h"

int C_PyTransform_TransformByMe(PyObject *self) {

	PyTransform *t = (PyTransform *)self;
        PyVector *v = (PyVector *)t->translation;

	glTranslated(v->vector[0], v->vector[1], v->vector[2]);
        v = (PyVector *)t->scale;	
	
	if (v->vector[0] != 0)
	{
	        glScaled(v->vector[0], v->vector[1], v->vector[2]);
	}
        if (t->rotationAmount != 0)
        {
                v = (PyVector *)t->rotationAxis;
	        glRotated(t->rotationAmount, v->vector[0], v->vector[1], 
                                v->vector[2]);
        }

	return 1;
	
}

int C_PyTransform_InvertByMe(PyObject *self) {

        PyTransform *t = (PyTransform *)self;
        PyVector *v;

        if (t->rotationAmount != 0)
        {
                v = (PyVector *)t->rotationAxis;
                glRotated(-t->rotationAmount, v->vector[0], v->vector[1],
                                v->vector[2]);
        }

        v = (PyVector *)t->scale;
        glScaled(1/v->vector[0], 1/v->vector[1], 1/v->vector[2]);

        v = (PyVector *)t->translation;
        glTranslated(-v->vector[0], -v->vector[1], -v->vector[2]);

	return 1;
	
}

int C_PyTransform_GenerateTransform(PyObject *self, PyObject *status,
                int time, int gen_forward, int gen_reverse, int apply)
{

        if (apply == 1)
                C_PyTransform_TransformByMe(self);
        else if (apply == -1)
                C_PyTransform_InvertByMe(self);

	return 1;
}

int C_PyTransform_RegisterSize(PyObject *self, int *result) 
{
	*result = 0;
	return 1;
}

int C_PyTransform_Register(PyObject *self, PyObject *status) {return 1;}

int C_PyTransform_Configure(PyObject *self, PyObject *status, PyObject *args) 
{
	return 1;
}

int C_PyTransform_DeRegister(PyObject *self, PyObject *status) {return 1;}
