#include "TograIncludes.h"
#include "PyVector_common.h"

int C_PyVector_Values(PyObject *v, double **result) {

        TOGRA_RETURN(((PyVector *)v)->vector);

}

int C_PyVector_Add(PyObject *a, PyObject *b, PyObject **result) {

        double *c, *d;
        
        PyVector *v = (PyVector *)a, *w = (PyVector *)b;
        c = v->vector;
        d = w->vector;
        
        TOGRA_RETURN((PyObject *)C_PyVector_New(c[0] + d[0], c[1] + d[1],
                        c[2] + d[2]));

}

int C_PyVector_Subtract(PyObject *a, PyObject *b, PyObject **result) {

        double *c, *d;
        
        PyVector *v = (PyVector *)a, *w = (PyVector *)b;
        c = v->vector;
        d = w->vector;
        
        TOGRA_RETURN((PyObject *)C_PyVector_New(c[0] - d[0], c[1] - d[1],
                        c[2] - d[2]));

}

int C_PyVector_TranslateByMe(PyObject *self) {
	
	PyVector *v = (PyVector *)self;
	
	glTranslated(v->vector[0], v->vector[1], v->vector[2]);

	TOGRA_SUCCEED;
}

int C_PyVector_RotateByMe(PyObject *self, double amt) {
	
	PyVector *v = (PyVector *)self;
	
	glRotated(amt, v->vector[0], v->vector[1], v->vector[2]);

	TOGRA_SUCCEED;
}

int C_PyVector_MultiplyScalar(PyObject *vector, double s, PyObject **result) {

        double *v = ((PyVector *)vector)->vector;
        TOGRA_RETURN(C_PyVector_New(v[0] * s, v[1] * s, v[2] * s));

}

int C_PyVector_Cross(PyObject *a, PyObject *b, PyObject **result) {

        double *c;
        double *d;

	C_PyVector_Values(a, &c);
	C_PyVector_Values(b, &d);

        TOGRA_RETURN((PyObject *)C_PyVector_New(c[1] * d[2] - c[2] * d[1],
                        c[2] * d[0] - c[0] * d[2], c[0] * d[1] - c[1] * d[0]));

}

