from Togra import *
from TograUtil import *
import math
import sys

scene = init()
pm = GraphMixin()
ode = ODEMixin()

try:
	friction = float(sys.argv[1])
	pm.setFriction(friction)
except:
	print "No friction specified"

try:
	repulsion = float(sys.argv[2])
	pm.setRepulsion(repulsion)
except:
	print "No repulsion specified"

scene.addMixin(pm)
scene.addMixin(ode)
ode.setGravity(Vector(0,0,0))

pauseQuitKeystrokes(scene)

scene.newLight(Vector(-10,10,0), (0.8,0.2,0.2,1))
scene.newLight(Vector(20,0,-10), (0.2,0.2,0.8,1))

def ODESphere(density, radius, position, velocity, segs, stacks):
	global pm
        t = sphere(0, 0, 0, radius, segs, stacks)
        o = ODETransform(ode)
        o.setSphere(density, radius)
        o.setPosition(position)
        o.setVelocity(velocity)
        t.transformContainer.append(o)
	i = pm.appendObject(o)
        return (t, o, i)

def connect(a, b):
	global pm
	pm.appendConnection(a, b, 8, 10)

a = ODESphere(1, 1, Vector(-10,0,0), Vector(0,0,0), 30, 30)
b = ODESphere(1, 1, Vector(0,0,0), Vector(0,0,0), 30, 30)
c = ODESphere(1, 1, Vector(0,10,10), Vector(0,0,0), 30, 30)
dd = ODESphere(1, 1, Vector(0,10,0), Vector(0,0,0), 30, 30)
connect(a[2], b[2])
connect(b[2], c[2])
connect(c[2], dd[2])
connect(dd[2], a[2])
connect(dd[2], b[2])
connect(c[2], a[2])

scene.baseContainer.append(a[0])
scene.baseContainer.append(b[0])
scene.baseContainer.append(c[0])
scene.baseContainer.append(dd[0])

scene.run()
