from Togra import *
from TograUtil import *

scene = init()
pauseQuitKeystrokes(scene)

scene.view_from = Vector(0,-30,-50)

path = circlePath(Vector(1,1,0), Vector(0,0,16.8), 10, 4000)
path2 = rotatePath(Vector(0,1,0), 3000)

box = box(0,0,-10,10,10,10)
box.setMaterial(Material(ambient=(0.5,0.3,0.3,1)))

outlineRect = Container(1)
faceRect = quadFace(-20,-20,-20,-19,20,-19,20,-20)
outlineRect.append(faceRect)
faceRect = quadFace(-20,-20,-20,20,-19,20,-19,-20)
outlineRect.append(faceRect)
faceRect = quadFace(-20,19,-20,20,20,20,20,19)
outlineRect.append(faceRect)
faceRect = quadFace(19,-20,19,20,20,20,20,-20)
outlineRect.append(faceRect)
NUM=40
GL_QUAD_STRIP=0x8
size_of_rect = 40.0/NUM
for i in range(NUM):
	l = lambda a:-20 + a*size_of_rect
	r = lambda a:-20 + (a+1)*size_of_rect
	vbox = VectorList(2 + 2 * NUM)
	vbox.append(Vector(l(i),-20,0))
	vbox.append(Vector(r(i),-20,0))
	for j in range(NUM):
		vbox.append(Vector(l(i),r(j),0))
		vbox.append(Vector(r(i),r(j),0))
		#faceRect = quadFace(l(i),l(j),r(i),l(j),r(i),r(j),l(i),r(j))
	sr = StaticRender(vbox, GL_QUAD_STRIP)
	face = Container()
	face.append(sr)
	outlineRect.append(face)
#faceRect = quadFace(-20,-20,20,-20,20,20,-20,20)
#outlineRect.append(faceRect)
outlineRect.setMaterial(Material(specular=(1,1,1,1), shininess=100, emissive=(0,0,0,1), ambient=(0,0,0,1)))

reflectRect = Container(1)
faceRect = quadFace(-20,-20,-20,20,20,20,20,-20)
reflectRect.append(faceRect)

transform = Translation(Vector(0,0,17))

tCont = TransformContainer()
tCont.append(transform)
tCont.append(path2)

boxCont = Container(3)
lightObj = sphere(0,-10,-30,1,10,10)
lightObj.setMaterial(Material(emissive=(1,0,0,1), ambient=(0.6,0.6,0.6,1)))
boxCont.append(lightObj)
boxCont.append(Light(diffuse=(0.6,0,0,1), location=Vector(0,-10,-30)))
lightObj2 = sphere(0,-20,0,1,10,10)
lightObj2.setMaterial(Material(emissive=(0,1,0,1), ambient=(0.6,0.6,0.6,1)))
boxCont.append(lightObj2)
boxCont.append(box)
s = sphere(0,0,0,1,10,10)
s.transformContainer.append(path)
s.setMaterial(Material(emissive=(0.6,0,1,1), ambient=(0.6,0.6,0.6,1)))
boxCont.append(s)
scene.newLight(Vector(0,0,0), (0.6,0,1,1), s.transformContainer)

reflection = Reflect(reflectRect, tCont, boxCont)

scene.newLight(Vector(0,-10,-30), (0.6,0,0,1))
scene.newLight(Vector(0,-20,0), (0,0.6,0,1))

scene.baseContainer.append(reflection)
scene.baseContainer.append(s)
scene.baseContainer.append(boxCont)
scene.baseContainer.append(outlineRect)
scene.baseContainer.transformContainer.append(
	rotatePath(Vector(1,0,0), 15000))

outlineRect.transformContainer.append(tCont)

scene.run()
