import gst
from Togra import GstTexture

def handle_error (element, orig_elem, error, message):
    if element.set_state (gst.STATE_READY) == gst.STATE_ASYNC:
        element.wait_state_change()

def handle_eos (element):
    print "Got EOS for %s" % (element.get_name())
    if element.set_state (gst.STATE_READY) == gst.STATE_ASYNC:
        element.wait_state_change()

    if element.set_state (gst.STATE_PLAYING) == gst.STATE_ASYNC:
        element.wait_state_change()

def handle_new_pad (element, pad, more_pads, connect_to, location):
    s = pad.get_caps()
    mime_type = s[0].get_name()

    print location, "new pad of type", mime_type
    if mime_type.startswith("video/x-raw") and not connect_to.is_linked():
        pad.link (connect_to)

def get_texture_objects(locations, placeholder):
	textures = []
	for location in locations:
		texture = GstTexture(256, 256)
		sink = texture.getSink()

		pipeline = gst.Pipeline()
                src = gst.element_factory_make ("gnomevfssrc")
                dec = gst.element_factory_make ("decodebin")
                cs = gst.element_factory_make ("ffmpegcolorspace")
                scale = gst.element_factory_make ("videoscale")

                pipeline.add (src, dec, cs, scale, sink)

                src.link(dec)
                cs.link (scale)
		scale.link(sink)

		src.set_property("location", location)
		# pipeline.set_property ("play-timeout", 0L)

                #pipeline.connect ('eos', handle_eos)
                #pipeline.connect ('error', handle_error)
                dec.connect ("new-decoded-pad", handle_new_pad, cs.get_pad ("sink"), location)

		pipeline.set_state(gst.STATE_PAUSED)
		pipeline.set_state(gst.STATE_PLAYING)
		textures.append(texture)
	return textures

def change_res(texture, res):
	sink = texture.getSink()
	sink.set_property("width", res)
	sink.set_property("height", res)

def change_vol(texture, res):
        pass
