from Togra import *
from TograUtil import *
import sys
import Tracker
import togragst

base = init()

t = Tracker.initTracker(base)
track = t

pauseQuitKeystrokes(base)

if len(sys.argv) == 2:
        fname = sys.argv[1]
else:
        fname = "/home/shans/alien.mpg"

SIZE = 25
GL_QUADS = 7

gst_tex = togragst.AutoGstTexture(512, 512, togragst.DVD, fname)
gst_tex2 = togragst.AutoGstTexture(256, 256, togragst.FILE, fname)

def do_dynamic_surface(a,b,c,d,e,f,g,h,i,j,k,l,m):
	surface = DynamicSurface(SIZE,SIZE)
	surface.splineSurface(a,b,c,d,e,f)
	surfaceb = DynamicSurface(SIZE,SIZE)
	surfaceb.splineSurface(g,h,i,j,k,l)
	surface.setBehaviour(InterpolationBehaviour(surfaceb, (int) (2000*m)))
	return surface

tc = FloatList(SIZE*SIZE)
for i in range(SIZE):
	for j in range(SIZE):
		tc.append(i/float(SIZE))
                tc.append(1.0 - j/float(SIZE))

surfaces = Container()
surface = do_dynamic_surface(
	Vector(10,0,20), Vector(40,0,20), Vector(50,0,0), Vector(0,10,10), 
		Vector(0,40,-10), Vector(0,50,0), 
	Vector(10,0,10), Vector(40,0,-10), Vector(50,0,0), Vector(0,10,20),
		Vector(0,40,20), Vector(0,50,0), 0.5)
surface.textureCoords = tc

surface2 = do_dynamic_surface(
	Vector(-10,0,20), Vector(-40,0,20), Vector(-50,0,0), Vector(0,10,10), 
		Vector(0,40,-10), Vector(0,50,0), 
	Vector(-10,0,-10), Vector(-40,0,10), Vector(-50,0,0), Vector(0,10,20),
		Vector(0,40,20), Vector(0,50,0), 0.5)
surface2.textureCoords = tc

surface3 = do_dynamic_surface(
	Vector(10,0,30), Vector(40,0,30), Vector(50,0,0), Vector(0,10,30), 
		Vector(0,40,30), Vector(0,50,0), 
	Vector(10,0,-30), Vector(40,0,-30), Vector(50,0,0), Vector(0,20,-30),
		Vector(0,30,-30), Vector(0,50,0), 2)
surface3.textureCoords = tc

surface4 = do_dynamic_surface(
	Vector(-10,0,30), Vector(-40,0,30), Vector(-50,0,0), Vector(0,10,30), 
		Vector(0,40,30), Vector(0,50,0), 
	Vector(-10,0,-30), Vector(-40,0,-30), Vector(-50,0,0), Vector(0,20,-30),
		Vector(0,30,-30), Vector(0,50,0), 2)
surface4.textureCoords = tc

surface2C = Container()
surface2C.append(surface2)
surface2C.append(surface4)
surface2C.transformContainer.append(Transform(translate=Vector(50,0,0)))

surfaceC = Container()
surfaceC.append(surface)
surfaceC.append(surface3)
surfaceC.append(surface2C)
surfaceC.transformContainer.append(Transform(translate=Vector(-25,-25,0)))
surfaceC.transformContainer.append(t)

surfaces.append(surfaceC)
m = Material(specular=(1,1,0,1), 
	shininess=50, emissive=(0,0,0,1), ambient=(0.5,0.5,1,1))
m.setTexture(gst_tex.texture)
surfaces.setMaterial(m)

base.newLight(Vector(-100,10,10), (1,0,0,1))
base.newLight(Vector(50,-30,30), (0,1,0,1))

base.setBackgroundColour(0,0,0)

scene = base
scene.newLight(Vector(0,20,-60),(0.6,0.6,0.6,1)) 

r1 = InterpolatedPath(3)
r1.setType(2)
r1.append((Vector(1,0.5,0.2), 0), 0)
r1.append((Vector(1,0.5,0.2), 360), 2000)
r1.setMaxIndex(2000)
                                                                                
r2 = InterpolatedPath(3)
r2.setType(2)
r2.append((Vector(0,0.5,1), 0), 0)
r2.append((Vector(0,0.5,1), 360), 20000)
r2.setMaxIndex(20000)

panelList = VectorList(8)
panelList.append(Vector(0,-5,-5))
panelList.append(Vector(0,5,-5))
panelList.append(Vector(0,5,5))
panelList.append(Vector(0,-5,5))
panelList.append(Vector(0,-5,-5))
panelList.append(Vector(0,-5,5))
panelList.append(Vector(0,5,5))
panelList.append(Vector(0,5,-5))

panelNormals = VectorList(8)
for i in range(4):
        panelNormals.append(Vector(1, 0, 0))
for i in range(4):
        panelNormals.append(Vector(-1, 0, 0))

panelTexture = FloatList(16)
for i in range(2):
        panelTexture.append(1.0)
        panelTexture.append(0.0)
        panelTexture.append(0.0)
        panelTexture.append(0.0)
        panelTexture.append(0.0)
        panelTexture.append(1.0)
        panelTexture.append(1.0)
        panelTexture.append(1.0)

sr = StaticRender(panelList, GL_QUADS, normals=panelNormals,
        textureCoords=panelTexture)

translations = [Vector(5, 0, 0), Vector(-5, 0, 0), Vector(0, 5, 0), 
               Vector(0, -5, 0), Vector(0, 0, 5), Vector(0, 0, -5)]

rotations = [Vector(1, 0, 0), Vector(1, 0, 0), Vector(0, 0, 1), Vector(0, 0, 1),
             Vector(0, 1, 0), Vector(0, 1, 0)]
rAmts = [0, 0, 90, 90, 90, 90]

box = Container(6)
box.transformContainer.append(r1)

for i in range(len(translations)):
    panel = Container(1)
    panel.append(sr)
    panel.transformContainer.append(Transform(translate=translations[i], 
            rotateAxis=rotations[i], rotateAmount=rAmts[i]))
    box.append(panel)


t = [Vector(0, 0, 20), Vector(-20, 0, 0), Vector(20, 0, 0),
    Vector(0, 0, -20), Vector(0, 20, 0), Vector(0, -20, 0)]

all = Container()

for i in t:
    step = Container(1)
    step.append(box)
    step.transformContainer.append(Transform(translate=i))
    all.append(step)

#textureImage = IntList(xsize*ysize)
#for pixel in im.getdata():
#	r, g, b = pixel
#	pixelValue = r | g << 8 | b << 16 
#	textureImage.append(pixelValue)

panelMaterial = Material(specular=(1,1,0,1),
        shininess=50, emissive=(0,0,0,1), ambient=(0.5,0.75,0.5,1))
panelMaterial.setTexture(gst_tex2.texture)
box.setMaterial(panelMaterial)


base.baseContainer.append (surfaces)
base.baseContainer.transformContainer.append(
	Transform(rotateAxis=Vector(0,1,0), rotateAmount=90))
scene.baseContainer.transformContainer.append(track)
scene.baseContainer.append(all)


scene.view_from = Vector(0,0,-80)
scene.run()
