from Togra import *
from TograUtil import *
import sys
import Image

GL_RGB		= 0x1907
im = Image.open(sys.argv[1])
im = im.convert("RGB")
im = im.resize((512,512))

base = init()

pauseQuitKeystrokes(base)

SIZE=50

tc = FloatList(SIZE*SIZE)
for i in range(SIZE):
	for j in range(SIZE):
		tc.append(i/float(SIZE))
		tc.append(1.0 - j/float(SIZE))

surface = DynamicSurface(SIZE,SIZE)
surface.splineSurface(
	Vector(10,0,20), Vector(40,0,20), Vector(50,0,0), Vector(0,10,10), 
		Vector(0,40,-10), Vector(0,50,0), 
	Vector(10,0,10), Vector(40,0,-10), Vector(50,0,0), Vector(0,10,20),
		Vector(0,40,20), Vector(0,50,0), 0.5)
surface.textureCoords = tc

surface2 = DynamicSurface(SIZE,SIZE)
surface2.splineSurface(
	Vector(-10,0,20), Vector(-40,0,20), Vector(-50,0,0), Vector(0,10,10), 
		Vector(0,40,-10), Vector(0,50,0), 
	Vector(-10,0,-10), Vector(-40,0,10), Vector(-50,0,0), Vector(0,10,20),
		Vector(0,40,20), Vector(0,50,0), 0.5)
surface2.textureCoords = tc

surface2C = Container()
surface2C.append(surface2)
surface2C.transformContainer.append(Transform(translate=Vector(50,0,0)))

surfaceC = Container()
surfaceC.append(surface)
surfaceC.append(surface2C)
surfaceC.transformContainer.append(Transform(translate=Vector(-25,-25,0)))
surfaceC.transformContainer.append(rotatePath(Vector(0,0,1), 60000))
surfaceC.transformContainer.append(rotatePath(Vector(1,0,0), 10000))
surfaceC.transformContainer.append(Transform(translate=Vector(0,0,50)))

base.baseContainer.append(surfaceC)
m = Material(specular=(1,1,0,1), 
	shininess=50, emissive=(0,0,0,1), ambient=(0.5,0.5,1,1))
m.setTexture(StaticTexture(im.tostring(), 512, 512, GL_RGB))
base.baseContainer.setMaterial(m)
base.baseContainer.transformContainer.append(
	Transform(rotateAxis=Vector(0,1,0), rotateAmount=90))

base.newLight(Vector(-50,30,-30), (1,0,0,1))
base.newLight(Vector(50,-30,30), (0,1,0,1))


base.run()
