from Togra import *
from TograUtil import *

base = init(1)

light_is_on = 0
is_rotating = 1
s1 = 0
s2 = 0

def handle_keystroke(key):
	global light_is_on, is_rotating, t1, t2, s1, s2
	if key == ord('l'):
		if light_is_on:
			base.deleteLight(light_is_on)
			light_is_on = 0
		else:
			t = TransformContainer()
			t.append(rotatePath(Vector(0.5,0.5,1), 20000))
			light_is_on = base.newLight(Vector(70,70,-70), 
				(1,1,1,1), t)
	elif key == ord('r'):
		if is_rotating:
			base.baseContainer.transformContainer = \
				TransformContainer()
			time = base.getTime()
			base1 = t1[0].getBaseTime()
			base2 = t2[0].getBaseTime()
			tMod1 = ((time - base1) % 4000) / 4000.0 * 360
			tMod2 = ((time - base2) % 5000) / 5000.0 * 360
			s1 = (tMod1 + s1) % 360
			s2 = (tMod2 + s2) % 360
			r1 = TransformContainer()
			r1.append(Transform(rotateAxis=Vector(1,0,0),
					rotateAmount = s1))
			r2 = TransformContainer()
			r2.append(Transform(rotateAxis=Vector(0,1,0),
					rotateAmount = s2))
			base.baseContainer.transformContainer.append(r1)
			base.baseContainer.transformContainer.append(r2)
			is_rotating = 0
		else:
			is_rotating = 1
			t1 = rotatePath(Vector(1,0,0), 4000)
			t2 = rotatePath(Vector(0,1,0), 5000)
			base.baseContainer.transformContainer[0].append(t1)
			base.baseContainer.transformContainer[1].append(t2)

pauseQuitKeystrokes(base, handle_keystroke)

cubeSide = StaticSurface(100, 100)
cubeSide.splineSurface(Vector(30,-10,-10), Vector(40,10,10), Vector(50,0,0),
	Vector(-10,30,-10), Vector(10,40,10), Vector(0,50,0))

cubeSide2 = StaticSurface(100,100)
cubeSide2.splineSurface(Vector(-10,10,10), Vector(-20,-10,-10), Vector(-50,0,0),
	Vector(-10,30,-10), Vector(10,40,10), Vector(0,50,0))

cubeSideC = Container()
cubeSideC.append(cubeSide)
cubeSideC.transformContainer.append(Translation(Vector(-25,-25,0)))
# cubeSideC is now centered around (0,0,0)

cubeSideC2 = Container()
cubeSideC2.append(cubeSide2)
cubeSideC2.transformContainer.append(Translation(Vector(25,-25,0)))

topFace = Container()
topFace.append(cubeSideC)
topFace.transformContainer.append(Transform(translate=Vector(0,0,25)))

topFace2 = Container()
topFace2.append(cubeSideC2)
topFace2.transformContainer.append(Transform(translate=Vector(0,0,-25)))

topFaces = Container()
topFaces.append(topFace)
topFaces.append(topFace2)

rightFace = Container()
rightFace.append(topFaces)
rightFace.transformContainer.append(Transform(rotateAxis=Vector(0,0,1),
	rotateAmount=90))
rightFace.transformContainer.append(Transform(rotateAxis=Vector(0,1,0),
	rotateAmount=90))

bottomFace = Container()
bottomFace.append(rightFace)
bottomFace.transformContainer.append(Transform(rotateAxis=Vector(0,0,1),
	rotateAmount=90))
bottomFace.transformContainer.append(Transform(rotateAxis=Vector(0,1,0),
	rotateAmount=90))


base.baseContainer.append(topFaces)
base.baseContainer.append(rightFace)
base.baseContainer.append(bottomFace)

base.baseContainer.setMaterial(Material(specular=(0.5,0.5,0.5,1),
	shininess=100))

t1 = TransformContainer()
t1.append(rotatePath(Vector(1,0,0), 4000))
t2 = TransformContainer()
t2.append(rotatePath(Vector(0,1,0), 5000))

base.baseContainer.transformContainer.append(t1)
base.baseContainer.transformContainer.append(t2)

base.newLight(Vector(0,0,-100), (1,0,0,1))
base.newLight(Vector(0,100,0), (0,1,0,1))
base.newLight(Vector(100,0,0), (0,0,1,1))

base.view_from = Vector(60,60,-60)

base.setBackgroundColour(0,0,0)
base.setAmbientLight(0,0,0,0)

base.run()
