from Togra import *
from TograUtil import *
import math

base = init()

pauseQuitKeystrokes(base)

GL_LINE_LOOP = 2
GL_TRIANGLE_FAN = 6
GL_QUAD_STRIP = 8        

def build_gear(inner, outer, spokes, angle):
        circ = circle(0, 0, inner, 10*spokes)
        circ2 = circle(0, 0, outer, 8*spokes)
        ang = - angle * math.pi / 180
        circ2.transform([[math.cos(ang) ,-math.sin(ang), 0],
                         [math.sin(ang),  math.cos(ang), 0],
                         [0, 0, 1]], Vector(0,0,0))

        circ3 = zip(circ, circ2, 2, 8, 3, 5)
        circ4 = extrude(circ3, Vector(0, 0,  5))        
        myRender2 = StaticRender(circ4, GL_QUAD_STRIP, normalMode=1, 
                                genNormals=1)

        circ5 = circle(0, 0, inner/2, 5 * spokes)
        circ6 = extrude(circ5, Vector(0, 0, -5))
        myRender3 = StaticRender(circ6, GL_QUAD_STRIP, normalMode=1,
                                genNormals=1)
        inner_part = Container(2)
        inner_part.append(myRender3)
        inner_part.transformContainer.append(Transform(translate=Vector(0,0,5)))

        circ7 = circle(0, 0, inner/2, 5 * spokes)
        c3r = circ3.reverse()
        ct = circ7.reverse()
        circ8 = zip(c3r, ct)
        circ8.append(circ8[0])
        circ8.append(circ8[1])
        myRender4 = StaticRender(circ8, GL_QUAD_STRIP, normalMode=1,
                                genNormals=1)
      
        circ9 = zip(circ3, circ7)
        circ9.append(circ9[0])
        circ9.append(circ9[1])
        myRender5 = StaticRender(circ9, GL_QUAD_STRIP, normalMode=1,
                                genNormals=1)

        inner_part.append(myRender5)
     
        c = Container(1)
        c.append(myRender2)
        c.append(inner_part)
        c.append(myRender4)
      
        #circ3.append(circ3[0])
        #circ3.insert(0, Vector(0,0,0))
        #c.append(StaticRender(circ3, GL_TRIANGLE_FAN))

        return c

i = InterpolatedPath(2)
i.setType(2)
i.append((Vector(0,1,0), 0), 0)
i.append((Vector(0,1,0), 360), 3000)
i.setMaxIndex(3000)

ir = InterpolatedPath(2)
ir.setType(2)
ir.append((Vector(0,1,0), 0), 0)
ir.append((Vector(0,1,0), -360), 4500)
ir.setMaxIndex(4500)

ir2 = InterpolatedPath(2)
ir2.setType(2)
ir2.append((Vector(0,1,0), 0), 0)
ir2.append((Vector(0,1,0), -360), 1000)
ir2.setMaxIndex(1000)

i2 = InterpolatedPath(3)
i2.setType(2)
i2.append((Vector(0,0,1), 0), 0)
i2.append((Vector(0,0,1), 360), 2000)
i2.setMaxIndex(2000)

i3 = InterpolatedPath(3)
i3.setType(2)
i3.append((Vector(1,0.5,0.2), 0), 0)
i3.append((Vector(1,0.5,0.2), 360), 6500)
i3.setMaxIndex(6500)

i4 = InterpolatedPath(3)
i4.setType(2)
i4.append((Vector(1,0.5,0.2), 0), 0)
i4.append((Vector(0,0.5,1), 360), 60000)
i4.setMaxIndex(60000)

e = Container(1)
e.transformContainer.append(i3)

c = build_gear(10, 15, 15, 12)
c.transformContainer.append(Transform(rotateAxis=Vector(1,0,0), rotateAmount=90))
c.transformContainer.append(i)
c.setMaterial(Material(ambient=(0.5,0,0,0)))
e.append(c)

c = build_gear(5, 10, 10, 18)
c.transformContainer.append(Transform(translate=Vector(0,5,0),rotateAxis=Vector(1,0,0), rotateAmount=90))
c.transformContainer.append(i)
c.setMaterial(Material(ambient=(0,0.5,0,0)))
e.append(c)

d = Container(1)
d.transformContainer.append(Transform(translate=Vector(22,5,0)))

c = build_gear(10, 15, 15, 12)
c.transformContainer.append(Transform(rotateAxis=Vector(1,0,0), rotateAmount=90))
c.setMaterial(Material(ambient=(0,0,0.5,0)))
c.transformContainer.append(ir)
d.append(c)
e.append(d)

f = cylinder(0,-2.5,0,10,30,50)
f.setMaterial(Material(ambient=(0.2,0.2,0.5,0)))
d.append(f)

g = box(0, 12.5, 5, 10, 2, 20)
g.setMaterial(Material(ambient=(0.2, 0.2, 0.5, 0)))
g.transformContainer.append(ir)
d.append(g)

h = build_gear(2, 5, 5, 32)
h.transformContainer.append(Transform(rotateAxis=Vector(1,0,0), rotateAmount=90))
h.setMaterial(Material(ambient=(0.3,0.2,0.3,0)))
h.transformContainer.append(ir2)

d = Container(1)
d.transformContainer.append(Transform(translate=Vector(-18,0,0)))

d.append(h)
e.append(d)

base.newLight(Vector(50,50,0), (1,1,1,1))
        
base.baseContainer.append(e)
base.baseContainer.transformContainer.append(i4)

base.setBackgroundColour(0.4,0.4,1)

base.view_from = Vector(0, 0, -50)

base.run()
