from Togra import *
import Image
import sys
import Tracker
import togragst

GL_QUADS        = 7

if len(sys.argv) < 7:
	print "Supply 6 media files as arguments"
	sys.exit(1)

scene = init()
track = Tracker.initTracker(scene)

scene.newLight(Vector(0,20,-60),(0.6,0.6,0.6,1)) 

r1 = InterpolatedPath(3)
r1.setType(2)
r1.append((Vector(1,0.5,0.2), 0), 0)
r1.append((Vector(1,0.5,0.2), 360), 2000)
r1.setMaxIndex(2000)
                                                                                
r2 = InterpolatedPath(3)
r2.setType(2)
r2.append((Vector(0,0.5,1), 0), 0)
r2.append((Vector(0,0.5,1), 360), 20000)
r2.setMaxIndex(20000)

panelList = VectorList(8)
panelList.append(Vector(0,-5,-5))
panelList.append(Vector(0,5,-5))
panelList.append(Vector(0,5,5))
panelList.append(Vector(0,-5,5))
panelList.append(Vector(0,-5,-5))
panelList.append(Vector(0,-5,5))
panelList.append(Vector(0,5,5))
panelList.append(Vector(0,5,-5))

panelNormals = VectorList(8)
for i in range(4):
        panelNormals.append(Vector(1, 0, 0))
for i in range(4):
        panelNormals.append(Vector(-1, 0, 0))

panelTexture = FloatList(16)
for i in range(2):
        panelTexture.append(1.0)
        panelTexture.append(0.0)
        panelTexture.append(0.0)
        panelTexture.append(0.0)
        panelTexture.append(0.0)
        panelTexture.append(1.0)
        panelTexture.append(1.0)
        panelTexture.append(1.0)

sr = StaticRender(panelList, GL_QUADS, normals=panelNormals,
        textureCoords=panelTexture)

translations = [Vector(5, 0, 0), Vector(-5, 0, 0), Vector(0, 5, 0), 
               Vector(0, -5, 0), Vector(0, 0, 5), Vector(0, 0, -5)]

rotations = [Vector(1, 0, 0), Vector(1, 0, 0), Vector(0, 0, 1), Vector(0, 0, 1),
             Vector(0, 1, 0), Vector(0, 1, 0)]
rAmts = [0, 0, 90, 90, 90, 90]
modes = [1, 0, 0, 0, 0, 0]

box = Container(6)
#box.transformContainer.append(r1)

for i in range(len(translations)):
    panel = Container(1)
    panel.append(sr)
    panel.transformContainer.append(Transform(translate=translations[i], 
            rotateAxis=rotations[i], rotateAmount=rAmts[i]))
    panelMaterial = Material()
    tex = togragst.AutoGstTexture (256, 128, modes[i], sys.argv[i+1])
    panelMaterial.setTexture(tex.texture)
    panel.setMaterial(panelMaterial)

    box.append(panel)

scene.view_from = Vector(0,0,-30)
scene.baseContainer.transformContainer.append(track)
scene.baseContainer.append(box)
scene.setBackgroundColour(0,0,0)

scene.run()
