from Togra import *
from TograUtil import *
import togragst

class TograLogo:
	def __init__(this, size, qual):
		this.size = size
		this.quality =  qual
		this.circle = circlePath(Vector(-1,1,0), Vector(0,0,this.size),
			4, 2400)
		this.logo = Container()
		#this.logo.transformContainer.append(Transform(
		#	rotateAxis=Vector(1,1,0), rotateAmount=45))

		rAmounts = [ 0, 60, 120, 180, -120, -60 ]

		colours = [ 
			( 0.63, 0.42, 0.47, 0.5 ),  # lt purple
			( 0.95, 0.30, 0.35, 0.5 ),  # red
			( 0.45, 0.21, 0.61, 0.5 ),  # purple
			( 0.00, 0.22, 0.68, 0.5 ),  # blue
			( 0.00, 0.60, 0.40, 0.5 ),  # green
			( 0.87, 0.71, 0.31, 0.5 )   # yellow
			  ]

		containers = []
		r1 = sphere(0, 0, 0, 12*size/30.0, qual, qual)
                r1.setMaterialCoords()
                m = Material()
                t = togragst.AutoGstTexture(256, 256, togragst.FILE, "/home/jan/media/mpeg/bullet.vob")
                m.setTexture(t.texture)
                r1.setMaterial(m)
		r = sphere(0, 0, 0, 12*size/30.0, qual, qual)
		for i in range(6):
			containers.append(Container())
                        m = Material(ambient=colours[i])

			containers[-1].setMaterial(m)
			h = containers[-1].transformContainer.append(
				this.circle)
			containers[-1].transformContainer.append(Transform(
				translate=Vector(0,0,0)))
			this.circle.setDelay(h, -2400 + i*2400/6)
                        if i == 0:
			    containers[-1].append(r1)
                        else:
			    containers[-1].append(r)

		map(this.logo.append, containers)
		this.offset = Vector(0,0,0)
		this.oldcircle = None
		this.movePath = None
		this.is_moving = 0

	def getContainer(this):
		return this.logo

	def finishFunc(this, container, delay):
		if this.circle == None:
			this.circle = circlePath(Vector(-1,1,0), 
				Vector(0,0,this.size), 4, 2400)
		container.transformContainer[0] = this.circle
		h = container.transformContainer.getItemHandle(0)
		container.transformContainer[0].setDelay(h, delay)
		container.transformContainer[1] = \
			Transform(translate=this.offset)
		this.is_moving -= 1

	def moveFunc(this, container):
		container.transformContainer[0] = this.movePath
		h = container.transformContainer.getItemHandle(0)
		container.transformContainer[0].setDelay(h, this.delay)
		container.transformContainer[0].setIterationScheme(h, 1)
		container.transformContainer[0].setCallback(h, 
			(this.finishFunc, container, this.delay))
		this.delay += 400

	def move(this, path):
		if this.is_moving > 0:
			return 0
		this.is_moving = 6
		for i in this.logo:
			h = i.transformContainer.getItemHandle(0)
			i.transformContainer[0].setIterationScheme(h, 2)
			i.transformContainer[0].setCallback(h, 
				(this.moveFunc, i))
		this.delay = 0
		this.movePath = InterpolatedPath()
		for item in path:
			this.movePath.append((Vector(0,0,this.size) + item[0],
				Vector(0,0,0) - item[1], item[1]), 
				item[2])

		this.movePath.setMaxIndex(path[-1][2])
		this.offset += path[-1][0]
		this.oldcircle = this.circle
		this.circle = None
		
		return 1

	def owns(this, ip):
		return this.oldcircle == ip[1] or this.movePath == ip[1]

if __name__ == "__main__":
	def mapFunc(list):
		list[0][2](*list[0][3:])

	ISPAUSED = [0]
	def myKb(*args):
		global c
		if args[0] == ord('q'):
			e.exit()                # this will exit!
		if args[0] == ord(' '):
			if ISPAUSED[0]:
			       e.cont()
			else:
			       e.pause()
			ISPAUSED[0] = not ISPAUSED[0]      
		if args[0] == ord('m'):
			path = [[Vector(0,0,0), Vector(-21,-21,0), 0],
				[Vector(0,30,0), Vector(0,12,0), 382],
				[Vector(0,60,30), Vector(0,0,15), 982],
				[Vector(0,30,60), Vector(0,-15,0), 1582],
				[Vector(0,-30,-60), Vector(0,-15,0), 2782],
				[Vector(0,-60,-30), Vector(0,0,15), 3382],
				[Vector(0,-30,0), Vector(0,12,0), 3982],
				[Vector(0,0,10), Vector(-21,-21,0), 4364]]
			logo.move(path)

	e = init()
	e.keyFunction = myKb        
	logo = TograLogo(30, 50)
	globl = e.baseContainer
	globl.append(logo.getContainer())
	globl[0].transformContainer.append(
		Transform(translate=Vector(80, 0, 0)))

	e.setBackgroundColour(0.04, 0.26, 0.46)
	e.newLight(Vector(-30, 0, 0), (0.8,0.8,0.8,1))

	e.messageFunction = mapFunc

	e.run()
