import pygst
pygst.require ("0.10")
import gst
from Togra import GstTexture

# Enums for AutoGstTexture pipelines
FILE, FILE_WITH_AUDIO, DVD, GOOM, GOOM_WITH_AUDIO, CUSTOM = range(6)

class AutoGstTexture:
    def __init__ (self, w, h, pipe_type, location=None, string=""):
        self.texture = GstTexture (w, h)
	if pipe_type == CUSTOM:
		self.pipeline = self.build_pipeline_from_str(string)
		if not location == None:
			src = self.pipeline.get_by_name ("src")
			if src:
				src.set_property ("location", location)
	else:
	        self.pipeline = self.build_pipeline(pipe_type, location)
        self.pipeline.set_state (gst.STATE_PLAYING)

    def build_pipeline_from_str (self, pipe_desc):
        sink = self.texture.getSink()
    
        pipeline = gst.parse_launch (pipe_desc)
        out_element = pipeline.get_by_name ("out")
        if out_element:
            sink_bin = out_element.get_parent ();
            sink_bin.add (sink);
	    out_element.link (sink)
    
        return pipeline
    
    def build_pipeline(self, pipe_type, location):
        pipes = {
            FILE: "gnomevfssrc name=src ! decodebin ! ffmpegcolorspace ! videoscale name=out",
            FILE_WITH_AUDIO : "gnomevfssrc name=src ! decodebin name=d ! ffmpegcolorspace  ! queue ! videoscale name=out d. ! queue ! audioconvert ! audioresample ! audio/x-raw-int,rate=48000 ! autoaudiosink",
            DVD:  "dvdnavsrc title=1 ! dvddemux name=demux .video_00 ! mpeg2dec ! ffmpegcolorspace ! videoscale name=out ",
            GOOM: "gnomevfssrc name=src ! decodebin ! audioconvert ! audioresample ! audio/x-raw-int,width=16,channels=2,rate=48000 ! audioconvert ! goom ! queue ! ffmpegcolorspace name=out",
            GOOM_WITH_AUDIO: "gnomevfssrc name=src ! decodebin ! tee name=t ! audioconvert ! audioresample ! audio/x-raw-int,width=16,channels=2,rate=48000 ! audioconvert ! goom ! queue ! ffmpegcolorspace name=out t. ! queue ! audioconvert ! alsasink"
        }
        pipeline = self.build_pipeline_from_str (pipes[pipe_type])
    
        if pipe_type in (FILE, FILE_WITH_AUDIO, GOOM, GOOM_WITH_AUDIO):
            src = pipeline.get_by_name ("src")
            if src:
                src.set_property ("location", location)

        return pipeline
