from Togra import *
from TograUtil import *

GL_QUADS = 7

scene = init()
pauseQuitKeystrokes(scene)

r1 = rotatePath(Vector(1, 0.5, 0.2), 6500)
r2 = rotatePath(Vector(0, 0.5, 1), 20000)

panelList = VectorList()
panelList.append(Vector(0,-5,-5))
panelList.append(Vector(0,5,-5))
panelList.append(Vector(0,5,5))
panelList.append(Vector(0,-5,5))
panelList.append(Vector(0,-5,-5))
panelList.append(Vector(0,-5,5))
panelList.append(Vector(0,5,5))
panelList.append(Vector(0,5,-5))

panelNormals = VectorList()
for i in range(4):
        panelNormals.append(Vector(1, 0, 0))
for i in range(4):
        panelNormals.append(Vector(-1, 0, 0))

panelTexture = FloatList()
for i in range(2):
        panelTexture.append(0.0)
        panelTexture.append(0.0)
        panelTexture.append(1.0)
        panelTexture.append(0.0)
        panelTexture.append(1.0)
        panelTexture.append(1.0)
        panelTexture.append(0.0)
        panelTexture.append(1.0)

panel = Container()
panel.append(StaticRender(panelList, GL_QUADS, normals=panelNormals,
        textureCoords=panelTexture))
panel.getTransformContainer().append(r1)

panelTexture = ""
for i in range(64):
        for j in range(64):
                if ((i & 0x8) and (j & 0x8)) or \
                        ((not (i & 0x8)) and (not (j & 0x8))):
			panelTexture += '\0\0' + chr(j << 2) + chr(i << 2)
                else:
			panelTexture += '\0' + chr((i + j) << 1) + \
				chr(j << 2) + chr(i << 2)
        
panelMaterial = Material(ambient=Colour(1, 1, 1, 1))
panelMaterial.setTexture(StaticTexture(panelTexture, 64, 64))
panel.setMaterial(panelMaterial)

scene.setViewFrom(Vector(-30,0,0))
scene.getBaseContainer().getTransformContainer().append(r2)
scene.getBaseContainer().append(panel)

scene.run()
