from Togra import *
from TograUtil import *
import Image
import sys

GL_QUADS        = 7
GL_RGB          = 0x1907
GL_BGR          = 0x80E0

#im = Image.open(sys.path[0] + "/test-texture.jpg")
im = Image.open(sys.argv[1])
im = im.convert("RGB")
xsize, ysize = im.size
if (xsize > 256) | (ysize > 256):
    xsize = 256
    ysize = 256
    im = im.resize ((xsize, ysize))
else:
    xsize = 64
    ysize = 64
    im = im.resize((xsize, ysize))

print xsize, ysize

scene = init()

pauseQuitKeystrokes(scene)

lightID = scene.newLight()
scene.setLightPosition(lightID, Vector(-60,20,0))
scene.setLightDiffuse(lightID, Colour(1,0.6,0.6,1)) 

r1 = InterpolatedPath(RotationInterpolation())
r1.append(((Vector(1,0.5,0.2), 0), 0))
r1.append(((Vector(1,0.5,0.2), 360), 2000))
r1.setMaxTime(2000)
                                                                                
r2 = InterpolatedPath(RotationInterpolation())
r2.append(((Vector(0,0.5,1), 0), 0))
r2.append(((Vector(0,0.5,1), 360), 20000))
r2.setMaxTime(20000)

panelList = VectorList()
panelList.append(Vector(0,-5,-5))
panelList.append(Vector(0,5,-5))
panelList.append(Vector(0,5,5))
panelList.append(Vector(0,-5,5))
panelList.append(Vector(0,-5,-5))
panelList.append(Vector(0,-5,5))
panelList.append(Vector(0,5,5))
panelList.append(Vector(0,5,-5))

panelNormals = VectorList()
for i in range(4):
        panelNormals.append(Vector(1, 0, 0))
for i in range(4):
        panelNormals.append(Vector(-1, 0, 0))

panelTexture = FloatList()
for i in range(2):
        panelTexture.append(1.0)
        panelTexture.append(0.0)
        panelTexture.append(0.0)
        panelTexture.append(0.0)
        panelTexture.append(0.0)
        panelTexture.append(1.0)
        panelTexture.append(1.0)
        panelTexture.append(1.0)

sr = StaticRender(panelList, GL_QUADS, normals=panelNormals,
        textureCoords=panelTexture)

translations = [Vector(5, 0, 0), Vector(-5, 0, 0), Vector(0, 5, 0), 
               Vector(0, -5, 0), Vector(0, 0, 5), Vector(0, 0, -5)]

rotations = [Vector(1, 0, 0), Vector(1, 0, 0), Vector(0, 0, 1), Vector(0, 0, 1),
             Vector(0, 1, 0), Vector(0, 1, 0)]
rAmts = [0, 0, 90, 90, 90, 90]

box = Container(6)
box.getTransformContainer().append(r1)

for i in range(len(translations)):
    panel = Container(1)
    panel.append(sr)
    panel.getTransformContainer().append(Transform(translation=translations[i], 
            rotationAxis=rotations[i], rotationAmount=rAmts[i]))
    box.append(panel)


t = [Vector(0, 0, 20), Vector(-20, 0, 0), Vector(20, 0, 0),
    Vector(0, 0, -20), Vector(0, 20, 0), Vector(0, -20, 0)]

all = Container()

for i in t:
    step = Container()
    step.append(box)
    step.getTransformContainer().append(Transform(translation=i))
    all.append(step)

panelMaterial = Material(ambient=Colour(1,1,1,1))
panelMaterial.setTexture(StaticTexture(im.tostring(), xsize, ysize, GL_RGB))
box.setMaterial(panelMaterial)

scene.setViewFrom(Vector(-60,0,0))
scene.getBaseContainer().getTransformContainer().append(r2)
scene.getBaseContainer().append(all)

scene.run()
